(*
 * The Caduceus certification tool
 * Copyright (C) 2003 Jean-Christophe Fillitre - Claude March
 * 
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * See the GNU General Public License version 2 for more details
 * (enclosed in the file GPL).
 *)

(*i $Id: coptions.mli,v 1.15 2006/01/27 14:55:17 marche Exp $ i*)

(*s environment variables *)

val libdir : string
val whylib : string

(*s command-line options *)

val zones : bool
val parse_only : bool
val type_only : bool
val print_norm : bool
val print_graph : bool
val debug : bool
val verbose : bool
val werror : bool
val with_cpp : bool
val cpp_command : string
val cpp_dump : bool
val why_opt : string
val coq_tactic : string
val separate : bool
val closed_program : bool

val files : unit -> string list 

val verify : string -> bool

(*s The log file *)

val log : Format.formatter;;
val lprintf : ('a, Format.formatter, unit) format -> 'a
val close_log : unit -> unit;;

